#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"

int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;

double *a;
double *b, *c;
a = (double *) malloc(N * sizeof(double) );
b = (double *) malloc(N * sizeof(double) );

int i, j;

for(i=0; i<N; i++) {
	a[i] = (double) i;
	//a[i] =  (rand() % 100);
}

get_ticks(ticksB4);

#pragma omp parallel for num_threads(nthreads) private(i,j) schedule(guided)
for(i=N-1;i>0;i=i-1)
{
	b[i] = 1;
	for(j=1;j<=a[i];j++)
	{
		b[i] = b[i]*j;
	}
}



get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

#if 0
printf("\na:");
for(i=0; i<N; i++) {
	printf(" %d", a[i]);
}
printf("\n\n");

printf("\nb:");
for(i=0; i<N; i++) {
	printf(" %.3g", b[i]);
}
printf("\n\n");
#endif

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
