#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"

int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;


double *a, *b, *c;
a = (double *) malloc(N * sizeof(double) );
b = (double *) malloc(N * sizeof(double) );

int i, j;

for(i=0; i<N; i++) {
	a[i] = (double) i;
	b[i] = (double) i;
	//a[i] = (double) rand() % 100;
}

get_ticks(ticksB4);

omp_set_nested(1);

#pragma omp parallel sections num_threads(2) private(i)
{

#pragma omp section
{
	for(i=1;i<N-1;i++)
	{
		a[i] = a[i-1] + a[i] + a[i+1];
	}
}

#pragma omp section
{
	#pragma omp parallel for num_threads(nthreads)
	for(i=1;i<N-1;i++)
	{
		double twob = pow(2,b[i]);
		double threeb = pow(3,b[i]);
		b[i] = twob + 1./twob + threeb + 1./threeb;
	}
}
}
get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;


#if 0
printf("\na:");
for(i=0; i<N; i++) {
	printf(" %.3g", a[i]);
}
printf("\n\n");

printf("\nb:");
for(i=0; i<N; i++) {
	printf(" %.3g", b[i]);
}
printf("\n\n");
#endif

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
